#define VERSION "mns-v.80beta"
#define AUTHORS "(c)1999 bind & aempirei"

#define _BSD_SOURCE
#define __BSD_SOURCE
#define __FAVOR_BSD
#define _USE_BSD

#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>
#include <errno.h>
#include <netdb.h>
#include <ctype.h>
#include <fcntl.h>
#include <time.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <rpc/rpc.h>
#include <rpc/pmap_prot.h>
#include <rpc/pmap_clnt.h>
#include <netinet/in_systm.h>
#include <sys/utsname.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>

#define VULNQPOP (1     )
#define VULNIMAP (1 << 1)
#define VULNCGI  (1 << 2)
#define VULNRPC  (1 << 3)
#define VULNFTP  (1 << 4)
#define RESOLVE  (1 << 5)
#define HOSTLIST (1 << 6)
#define ALLVULNS ~(RESOLVE | HOSTLIST)

#define ERROR -1
#define TIMEOUT 3

#define SA   struct sockaddr
#define SAin struct sockaddr_in

#define IPV4_ADDRLEN 16

#define stralloc(a,b)\
 {a->string = malloc(strlen(b) + 1);\
 strcpy((a)->string, (b));\
 (a)->next = calloc(sizeof(struct node),1);\
 a = (a)->next;}

#define min(a, b) (((a) < (b)) ? (a) : (b))
#define max(a, b) (((a) > (b)) ? (a) : (b))

struct node {
   char *string;
   struct node *next;
};

/* ipv4.c */
extern const char *ipv4_ntop(int, const void *, char *, size_t);
extern const char *ipv4_showname(int, const void *, char *, size_t);
extern u_short tcp_cksum(char *, int, struct in_addr, struct in_addr);
extern u_short in_cksum(u_short *, int);
extern int ipv4_rslvhost(char *, SAin *);
extern int hamming(u_long);

/* osdetect.c */
extern struct node *stealthscan(struct in_addr, struct node *,
                                int **, struct in_addr *);
extern struct node *checkos(struct in_addr, struct node *,
                            int *, struct in_addr);

extern void sighandler (int);

/* scan.c */
extern struct node *rpc(struct in_addr, struct node *);
extern struct node *qpop(struct in_addr, struct node *);
extern struct node *imap(struct in_addr, struct node *);
extern struct node *cgi(struct in_addr, struct node *);
extern struct node *ftp(struct in_addr, struct node *);

