#include "mns.h"
#define timed_read(a,b,c) { alarm(TIMEOUT); read(a,b,c); alarm(0); }

#define BUFFER_SIZE 160
#define CGI_BUF_SIZE 240
#define CGIMAX 21
static const char *cginame[CGIMAX] = {
  "phf", "Count.cgi", "test-cgi", "php.cgi", "handler", "webgais",
  "websendmail", "webdist.cgi", "faxsurvey", "htmlscript", "pfdisplay",
  "perl.exe", "wwwboard.pl", "www-sql", "aglimpse", "man.sh",
  "view-source", "campas", "nph-test-cgi" };

struct node *
qpop (struct in_addr target, struct node *walk)
{

  int sockfd;
  char *buffer;
  SAin qpop;

  qpop.sin_family = AF_INET;
  qpop.sin_port = htons (110);
  qpop.sin_addr = target;

  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return walk;

  signal (SIGALRM, &sighandler);

  alarm (TIMEOUT);

  if (!connect (sockfd, (SA *) & qpop, sizeof (SAin)))
    {
      alarm (0);
      sleep (1);

      buffer = calloc (BUFFER_SIZE, 1);

      timed_read (sockfd, buffer, BUFFER_SIZE - 1);

      /* thanks diab */

      if ((strstr (buffer, "QPOP")) != NULL)
	{
	  if ((strstr (buffer, "2.2")) != NULL)
	    stralloc (walk, "\n   QPOP 2.2\n");

	  if ((strstr (buffer, "2.41beta1")) != NULL)
	    stralloc (walk, "\n   QPOP 2.41beta1\n");

	  if ((strstr (buffer, "2.3")) != NULL)
	    stralloc (walk, "\n   QPOP 2.3\n");

	  if ((strstr (buffer, "2.4")) != NULL)
	    stralloc (walk, "\n   QPOP 2.4\n");

	  if ((strstr (buffer, "2.1.4-R3")) != NULL)
	    stralloc (walk, "\n   QPOP 2.1.4-R3\n");
	}

      if ((strstr (buffer, "SCO")) != NULL)
	{
	  if ((strstr (buffer, "2.1.4-R3")) != NULL)
	    stralloc (walk, "\n   SCO POP 2.1.4-R3\n");

	  if ((strstr (buffer, "5.0.0")) != NULL)
	    stralloc (walk, "\n   SCO POP 5.0.0\n");
	}

      free (buffer);
    }
  close (sockfd);

  return walk;
}

struct node *
imap (struct in_addr target, struct node *walk)
{

  int sockfd;
  char *buffer;
  SAin imap;

  imap.sin_family = AF_INET;
  imap.sin_port = htons (143);
  imap.sin_addr = target;


  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return walk;


  signal (SIGALRM, &sighandler);

  alarm (TIMEOUT);


  if (!connect (sockfd, (SA *) & imap, sizeof (SAin)))
    {
      alarm (0);
      sleep (1);

      buffer = calloc (BUFFER_SIZE, 1);
      timed_read (sockfd, buffer, BUFFER_SIZE - 1);

      if ((strstr (buffer, "IMAP4rev1 v10.223")) != NULL)
	stralloc (walk, "\n   IMAP4rev1 v10.223\n");

      if ((strstr (buffer, "IMAP4rev1 Service 9.0")) != NULL)
	stralloc (walk, "\n   IMAP4rev1 Service 9.0\n");

      if ((strstr (buffer, "IMAP4rev1 v10.205")) != NULL)
	stralloc (walk, "\n   IMAP4rev1 v10.205\n");

      if ((strstr (buffer, "IMAP4rev1 v10.203")) != NULL)
	stralloc (walk, "\n   IMAP4rev1 v10.203\n");

      if ((strstr (buffer, "IMAP4rev1 v10.171")) != NULL)
	stralloc (walk, "\n   IMAP4rev1 v10.171\n");

      if ((strstr (buffer, "IMAP4rev1 v10.183")) != NULL)
	stralloc (walk, "\n   IMAP4rev1 v10.183\n");

      if ((strstr (buffer, "IMAP4rev1 v10.166")) != NULL)
	stralloc (walk, "\n   IMAP4rev1 v10.166\n");

      if ((strstr (buffer, "IMAP4rev1 v10.233")) != NULL)
	stralloc (walk, "\n   IMAP4rev1 v10.233\n");

      if ((strstr (buffer, "IMAP4rev1 v10.190")) != NULL)
	stralloc (walk, "\n   IMAP4rev1 v10.190\n");

      free (buffer);
    }

  close (sockfd);

  return walk;
}

struct node *
cgi (struct in_addr target, struct node *head)
{

  int sockfd, sockfd1st;
  int i;

  SAin http;
  struct node *walk = head;
  char cgimsg[70];
  char cgibuff[CGI_BUF_SIZE];

  http.sin_family = AF_INET;
  http.sin_port = htons (80);
  http.sin_addr = target;

  if ((sockfd1st = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return walk;

  signal (SIGALRM, &sighandler);

  /*lazy style */
  stralloc (walk, "\n   CGI ->");

  alarm (TIMEOUT);

  if (!connect (sockfd1st, (SA *) & http, sizeof (SAin)))
    {
      alarm (0);
      close (sockfd1st);
      for (i = 0; i < CGIMAX; i++)
	{
	  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
	    break;

	  alarm (TIMEOUT);
	  if (!connect (sockfd, (SA *) & http, sizeof (SAin)))
	    {
	      alarm (0);
	      bzero (cgibuff, CGI_BUF_SIZE);
	      sprintf (cgimsg, "GET /cgi-bin/%s HTTP/1.0\n\n", cginame[i]);

	      write (sockfd, cgimsg, strlen (cgimsg));
	      timed_read (sockfd, cgibuff, CGI_BUF_SIZE - 1);

	      if (strstr (cgibuff, "200") != NULL)
		stralloc (walk, cginame[i]);

	    }
	  alarm (0);
	  close (sockfd);
	}
    }

  alarm (0);
  close (sockfd1st);

  if ((head->next)->next == NULL)
    {
      free (head->string);
      free (head->next);
      bzero (head, sizeof (struct node));
      return head;
    }
  else
    return walk;
}

struct node *
ftp (struct in_addr target, struct node *walk)
{
  int sockfd;
  char *buffer;
  SAin saftp;

  saftp.sin_family = AF_INET;
  saftp.sin_port = htons (21);
  saftp.sin_addr = target;

  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return walk;

  signal (SIGALRM, &sighandler);

  alarm (TIMEOUT);
  if (!connect (sockfd, (SA *) & saftp, sizeof (SAin)))
    {
      alarm (0);
      sleep (1);

      buffer = calloc (BUFFER_SIZE, 1);

      timed_read (sockfd, buffer, BUFFER_SIZE - 1);
      if ((strstr (buffer, "2.4.2-academ[BETA-18]")) != NULL)
	if ((strstr (buffer, "VR")) == NULL)
	  stralloc (walk, "\n   Wu-FTP 2.4.2-academ[BETA-18]\n");
      if ((strstr (buffer, "Wu-FTPD 2.4.2-academ[BETA-16]")) != NULL)
	stralloc (walk, "\n   Wu-FTP 2.4.2-academ[BETA-16]\n");
      if ((strstr (buffer, "Wu-FTPD 2.4.2-academ[BETA-15]")) != NULL)
	stralloc (walk, "\n   Wu-FTP 2.4.2-academ[BETA-15]\n");
      if ((strstr (buffer, "ProFTPD")) != NULL)
	if ((strstr (buffer, "1.2.0pre1")) != NULL)
	  stralloc (walk, "\n   ProFTPD 1.2.0pre1\n");

      free (buffer);
    }
  close (sockfd);

  return walk;
}
